# -----------------------------------------------------------
# configure cron
# -----------------------------------------------------------
#!/bin/sh
echo "Adding zerotier name and description updater script..."
OUTFILE=/home/admin/ztUpdateNameDesc.sh
(
sudo cat <<'EOF'
#!/bin/sh

#Write Device Name and Description to joined ZeroTier Networks

netIDArr=$(zerotier-cli listnetworks | sed '1d' | awk '{print $3}')

SAVEIFS=$IFS		# Save current IFS (Internal Field Separator)
IFS=$'\n'		# Change IFS to newline char
netIDArr=($netIDArr)	# split the `netIDArr` string into an array by the same name
IFS=$SAVEIFS		# Restore original IFS

echo "Node ID: ${netIDArr[@]}"

ztInfo=$(zerotier-cli info)
serialNum=$(/sbin/fw_printenv -n serial#)
productName=$(/sbin/fw_printenv -n DeviceDesc)
read -ra ztInfoArr <<< "$ztInfo" #put info into array
memID="${ztInfoArr[2]}" 
onlineStatus="${ztInfoArr[4]}"

echo "Updating Name to: '${HOSTNAME}'"
echo "Updating Description to: '${productName} ${serialNum}'"
for (( i=0; i<${#netIDArr[@]}; i++ )) #iterate through all joined networks and apply Name and Description
do
	curl -X POST https://my.zerotier.com/api/v1/network/${netIDArr[$i]}/member/$memID -H "Authorization: bearer jwmLSfkS9dedZq1NPceja7FzQJm3ji34" -d '{"name": "'${HOSTNAME}'","description": "'"${productName}"' '"${serialNum}"'"}'
	echo "Updated on Network ID ${netIDArr[$i]}"
done


EOF
) > $OUTFILE
if [ -f "$OUTFILE" ]
then

  chmod 744 $OUTFILE
  # Make the generated file executable.

  echo 'Updating ZeroTier Name and Description'
  sh ztUpdateNameDesc.sh

else

  echo "Problem in creating file: \"$OUTFILE\""

fi